from lib.snabbdom import h

class CorpusExample:
    def __init__(self):
        self.other_attributes = {}
    
    def import_xml(self, example_xml):
        for oth_attr in ["example_id", "modified", "lexical_unit_id", "audio"]:
            if example_xml.hasAttribute(oth_attr):
                self.other_attributes[oth_attr] = example_xml.getAttribute(oth_attr)
            
    def export(self, doc):
        result = doc.createElement("corpusExample")
        for key, value in self.other_attributes.items():
            result.setAttribute(key, value)
        return result
    
    def get_cluster(self):
        return None
    
    def get_structure(self):
        return None
    
    def view(self, components):
        return [h("span" + comp.view_style(), {}, comp.text) for comp in components]
    
